'\"
'\" This code and documentation copyright to Flynt Consulting Services.
'\" 
'\" Permission to use, copy, modify, and distribute this software and its
'\" documentation for any purpose and without fee is hereby granted, provided
'\" that the above copyright notice appear in all copies and that both that the
'\" copyright notice and warranty disclaimer appear in supporting documentation,
'\" and that the name of Flynt Consulting Services not be used
'\" in advertising or publicity pertaining to distribution of the software
'\" without specific, written prior permission.
'\"
'\" This man format is covered by the following copyright:
'\" Copyright (c) 1990-1994 The Regents of the University of California.
'\" Copyright (c) 1994-1996 Sun Microsystems, Inc.
'\"
'\" 
'\" SCCS: @(#) button.n 1.40 97/10/31 12:58:48
'\" 
'\" The definitions below are for supplemental macros used in Tcl/Tk
'\" manual entries.
'\"
'\" .AP type name in/out ?indent?
'\"	Start paragraph describing an argument to a library procedure.
'\"	type is type of argument (int, etc.), in/out is either "in", "out",
'\"	or "in/out" to describe whether procedure reads or modifies arg,
'\"	and indent is equivalent to second arg of .IP (shouldn't ever be
'\"	needed;  use .AS below instead)
'\"
'\" .AS ?type? ?name?
'\"	Give maximum sizes of arguments for setting tab stops.  Type and
'\"	name are examples of largest possible arguments that will be passed
'\"	to .AP later.  If args are omitted, default tab stops are used.
'\"
'\" .BS
'\"	Start box enclosure.  From here until next .BE, everything will be
'\"	enclosed in one large box.
'\"
'\" .BE
'\"	End of box enclosure.
'\"
'\" .CS
'\"	Begin code excerpt.
'\"
'\" .CE
'\"	End code excerpt.
'\"
'\" .VS ?version? ?br?
'\"	Begin vertical sidebar, for use in marking newly-changed parts
'\"	of man pages.  The first argument is ignored and used for recording
'\"	the version when the .VS was added, so that the sidebars can be
'\"	found and removed when they reach a certain age.  If another argument
'\"	is present, then a line break is forced before starting the sidebar.
'\"
'\" .VE
'\"	End of vertical sidebar.
'\"
'\" .DS
'\"	Begin an indented unfilled display.
'\"
'\" .DE
'\"	End of indented unfilled display.
'\"
'\" .SO
'\"	Start of list of standard options for a Tk widget.  The
'\"	options follow on successive lines, in four columns separated
'\"	by tabs.
'\"
'\" .SE
'\"	End of list of standard options for a Tk widget.
'\"
'\" .OP cmdName dbName dbClass
'\"	Start of description of a specific option.  cmdName gives the
'\"	option's name as specified in the class command, dbName gives
'\"	the option's name in the option database, and dbClass gives
'\"	the option's class in the option database.
'\"
'\" .UL arg1 arg2
'\"	Print arg1 underlined, then print arg2 normally.
'\"
'\" SCCS: @(#) man.macros 1.9 97/08/22 18:50:59
'\"
'\"	# Set up traps and other miscellaneous stuff for Tcl/Tk man pages.
.if t .wh -1.3i ^B
.nr ^l \n(.l
.ad b
'\"	# Start an argument description
.de AP
.ie !"\\$4"" .TP \\$4
.el \{\
.   ie !"\\$2"" .TP \\n()Cu
.   el          .TP 15
.\}
.ie !"\\$3"" \{\
.ta \\n()Au \\n()Bu
\&\\$1	\\fI\\$2\\fP	(\\$3)
.\".b
.\}
.el \{\
.br
.ie !"\\$2"" \{\
\&\\$1	\\fI\\$2\\fP
.\}
.el \{\
\&\\fI\\$1\\fP
.\}
.\}
..
'\"	# define tabbing values for .AP
.de AS
.nr )A 10n
.if !"\\$1"" .nr )A \\w'\\$1'u+3n
.nr )B \\n()Au+15n
.\"
.if !"\\$2"" .nr )B \\w'\\$2'u+\\n()Au+3n
.nr )C \\n()Bu+\\w'(in/out)'u+2n
..
.AS Tcl_Interp Tcl_CreateInterp in/out
'\"	# BS - start boxed text
'\"	# ^y = starting y location
'\"	# ^b = 1
.de BS
.br
.mk ^y
.nr ^b 1u
.if n .nf
.if n .ti 0
.if n \l'\\n(.lu\(ul'
.if n .fi
..
'\"	# BE - end boxed text (draw box now)
.de BE
.nf
.ti 0
.mk ^t
.ie n \l'\\n(^lu\(ul'
.el \{\
.\"	Draw four-sided box normally, but don't draw top of
.\"	box if the box started on an earlier page.
.ie !\\n(^b-1 \{\
\h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.el \}\
\h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\l'|0u-1.5n\(ul'
.\}
.\}
.fi
.br
.nr ^b 0
..
'\"	# VS - start vertical sidebar
'\"	# ^Y = starting y location
'\"	# ^v = 1 (for troff;  for nroff this doesn't matter)
.de VS
.if !"\\$2"" .br
.mk ^Y
.ie n 'mc \s12\(br\s0
.el .nr ^v 1u
..
'\"	# VE - end of vertical sidebar
.de VE
.ie n 'mc
.el \{\
.ev 2
.nf
.ti 0
.mk ^t
\h'|\\n(^lu+3n'\L'|\\n(^Yu-1v\(bv'\v'\\n(^tu+1v-\\n(^Yu'\h'-|\\n(^lu+3n'
.sp -1
.fi
.ev
.\}
.nr ^v 0
..
'\"	# Special macro to handle page bottom:  finish off current
'\"	# box/sidebar if in box/sidebar mode, then invoked standard
'\"	# page bottom macro.
.de ^B
.ev 2
'ti 0
'nf
.mk ^t
.if \\n(^b \{\
.\"	Draw three-sided box if this is the box's first page,
.\"	draw two sides but no top otherwise.
.ie !\\n(^b-1 \h'-1.5n'\L'|\\n(^yu-1v'\l'\\n(^lu+3n\(ul'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.el \h'-1.5n'\L'|\\n(^yu-1v'\h'\\n(^lu+3n'\L'\\n(^tu+1v-\\n(^yu'\h'|0u'\c
.\}
.if \\n(^v \{\
.nr ^x \\n(^tu+1v-\\n(^Yu
\kx\h'-\\nxu'\h'|\\n(^lu+3n'\ky\L'-\\n(^xu'\v'\\n(^xu'\h'|0u'\c
.\}
.bp
'fi
.ev
.if \\n(^b \{\
.mk ^y
.nr ^b 2
.\}
.if \\n(^v \{\
.mk ^Y
.\}
..
'\"	# DS - begin display
.de DS
.RS
.nf
.sp
..
'\"	# DE - end display
.de DE
.fi
.RE
.sp
..
'\"	# SO - start of list of standard options
.de SO
.SH "STANDARD OPTIONS"
.LP
.nf
.ta 4c 8c 12c
.ft B
..
'\"	# SE - end of list of standard options
.de SE
.fi
.ft R
.LP
See the \\fBoptions\\fR manual entry for details on the standard options.
..
'\"	# OP - start of full description for a single option
.de OP
.LP
.nf
.ta 4c
Command-Line Name:	\\fB\\$1\\fR
Database Name:	\\fB\\$2\\fR
Database Class:	\\fB\\$3\\fR
.fi
.IP
..
'\"	# CS - begin code excerpt
.de CS
.RS
.nf
.ta .25i .5i .75i 1i
..
'\"	# CE - end code excerpt
.de CE
.fi
.RE
..
.de UL
\\$1\l'|0\(ul'\\$2
..
.TH tree n 2.2 tree "Tcl/Tk for Real Programmers"
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
tree \- A tree structure container object Tcl/Tk
.SH SYNOPSIS
\fBnewTreeObject\fR 
.BE
.SH DESCRIPTION
The \fBnewTreeObject\fR command creates a new tree base node, and
returns the handle to be used to manipulate that node.  The handle
is a procedure with several subcommands.
.PP
The tree object is designed to be used when the data being represented
naturally falls into a tree structure.  For example, a file system,
a set of news articles (with follups), or a multi-part mime mail message
are best represented as a tree rather than a flat data object (like
the simple Tcl associative array.)
.PP
.SH "TREE COMMAND"
.PP
The \fBnewTreeObject\fR command creates a new Tcl command whose
name is returned when the node is created.  This
command may be used to invoke various
operations on the widget.  It has the following general form:
.PP
.CS
\fIpathName subcommand \fR?\fIarg arg ...\fR?
.CE
.PP
\fISubcommand\fR and the \fIarg\fRs
determine the exact behavior of the command.  The following
commands are possible for tree object:
.TP
\fIpathName \fBadd\fR 
Add a new child node to this node.  Returns a handle for accessing
the new node.
.TP
\fIpathName \fBdelete\fR ?\fI-r\fR?
Deletes this node and all data associated with it.  If the \fI-r\fR
option is set, all child nodes are also deleted.  If no option is used,
this nodes child nodes are relinked to be children of the node's parent.
.TP
\fIpathName \fBdestroyTree\fR 
Delete this entire tree.
.TP
\fIpathName \fBset\fR ?\fI-node -tree\fR? \fIkey value\fR
Attaches the \fIvalue\fR to this node.  The value can
be retrieved using the \fBget\fR command, and the \fIkey\fR.
The \fI-node\fR and \fI-tree\fR options control whether the 
\fIvalue\fR is attached to the current node (and can only be 
retrieved from this node), or attached to the tree (and can be
retrieved from any node.)
.TP
\fIpathName \fBappend\fR ?\fI-node -tree\fR? \fIkey value\fR
Appends the contents of \fIvalue\fR to previous data attached to this node.  The value can
be retrieved using the \fBget\fR command, and the \fIkey\fR.
The \fI-node\fR and \fI-tree\fR options control whether the 
\fIvalue\fR is attached to the current node (and can only be 
retrieved from this node), or attached to the tree (and can be
retrieved from any node.)
.TP
\fIpathName \fBlappend\fR ?\fI-node -tree\fR? \fIkey value\fR
Appends the contents of \fIvalue\fR to previous data attached to this node as a list.  The value can
be retrieved using the \fBget\fR command, and the \fIkey\fR.
The \fI-node\fR and \fI-tree\fR options control whether the 
\fIvalue\fR is attached to the current node (and can only be 
retrieved from this node), or attached to the tree (and can be
retrieved from any node.)
.TP
\fIpathName \fBget\fR ?\fI-node -tree -best\fR? \fIkey\fR
Retrieves the \fIvalue\fR referenced by \fIkey\fR from this node. 
The \fI-node\fR and \fI-tree\fR options control whether the 
\fIvalue\fR is retrieved from the current node, or retrieved from the tree.
The \fI-best\fR option checks first on the node, and if the key
is not set for this node, checks for a key in the tree.
The default is \fI-best\fR.
.TP
\fIpathName \fBunset\fR ?\fI-node -tree\fR? \fIkey\fR
Deletes the \fIvalue\fR associated with this key.
The \fI-node\fR and \fI-tree\fR options control whether the 
\fIvalue\fR is destroyed on the current node, or the tree.
.TP
\fIpathName \fBchildList\fR 
Return the list of child nodes attached to this node.
.TP
\fIpathName \fBsearch glob\fR 
Return the list of child nodes attached to this node that match a glob pattern.
.TP
\fIpathName \fBsiblingList\fR 
Return the list of child nodes attached to this node's parent.
.TP
\fIpathName \fBparent\fR 
Return the parent of this node.
.TP
\fIpathName \fBvalueList\fR ?\fI-node -tree\fR?
Return the list of all the keys and data associated with this node or tree.
The data is returned as a list of lists, each list consists of key and data.
.PP
ie. {{key1 data1} {key2 {multiword data2}} {{multi word key} {multiword data}}}
.TP
\fIpathName \fBkeyList\fR ?\fI-node -tree\fR?
Return the list of all the keys associated with this node or tree.
The data is returned as a list of lists, each list consists of keys,
.PP
ie. {key1 key2 {multi word key}}
.TP
\fIpathName \fBbase\fR 
Returns the ultimate ancestor of this node.
.TP
\fIpathName \fBgetNodes\fR 
Returns a list of all nodes in the tree, regardless of parent or child
relationship.
.TP
\fIpathName \fBdump\fR 
An ascii dump of this tree, all nodes, children and associated keys and data.
Primarily used for debugging.

\
.SH EXAMPLE
.DS
package require tree 2.1

# Test creating trees
            
set mytree [newTreeObject]] 
             
# Test methods for setting and getting id/value pairs.

set tmp [$mytree set -node id1 value1]
.BR
if {![string match  $tmp "value1"]} {
    error "Failed to get expected return from set \\
    -node:  $tmp != value1"
.BR
}

set tmp [$mytree get -node id1]    
.BR
if {![string match  $tmp "value1"]} {
    error "Failed to get expected return from get \\
    -node:  $tmp != value1"
.BR
}
.DE    


.SH KEYWORDS
tree data key

